accounts/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView
from accounts.views import signup

urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(), name="logout"),
    path("signup/", signup, name="signup"),
]

projects/urls.py
from django.urls import path
from .views import ProjectListView, ProjectDetailView, ProjectCreateView


urlpatterns = [
    path("", ProjectListView.as_view(), name="list_projects"),
    path("<int:pk>/", ProjectDetailView.as_view(), name="show_project"),
    path("create/", ProjectCreateView.as_view(), name="create_project"),
]

tasks/urls.py
from django.urls import path
from .views import TaskCreateView, TaskListView

urlpatterns = [
    path("create/", TaskCreateView.as_view(), name="create_task"),
    path("mine/", TaskListView.as_view(), name="show_my_tasks"),
]

tracker/urls.py
from django.contrib import admin
from django.urls import path, include

from projects.views import ProjectRedirectView

urlpatterns = [
    path("admin/", admin.site.urls),
    path("projects/", include("projects.urls")),
    path("accounts/", include("accounts.urls")),
    path(
        "",
        ProjectRedirectView.as_view(),
        name="home",
    ),
    path("tasks/", include("tasks.urls")),
]

accounts/models.py
from django.db import models

# Create your models here.

projects/models.py
from django.db import models
from django.conf import settings

# Create your models here.

USER_MODEL = settings.AUTH_USER_MODEL


class Project(models.Model):
    name = models.CharField(max_length=200)
    description = models.TextField()
    members = models.ManyToManyField(USER_MODEL, related_name="projects")

    def __str__(self):
        return self.name

tasks/models.py
from django.db import models
from django.conf import settings


USER_MODEL = settings.AUTH_USER_MODEL


class Task(models.Model):
    name = models.CharField(max_length=200)
    start_date = models.DateTimeField()
    due_date = models.DateTimeField()
    is_completed = models.BooleanField(default=False)
    project = models.ForeignKey(
        "projects.Project",
        related_name="tasks",
        on_delete=models.CASCADE,
    )
    assignee = models.ForeignKey(
        USER_MODEL, null=True, related_name="tasks", on_delete=models.SET_NULL
    )

    def __str__(self):
        return self.name

accounts/views.py
from django.shortcuts import render, redirect
from django.contrib.auth.forms import UserCreationForm
from django.contrib.auth import login
from django.contrib.auth.models import User

# Create your views here.


def signup(request):
    if request.method == "POST":
        form = UserCreationForm(request.POST)
        if form.is_valid():
            username = request.POST.get("username")
            password = request.POST.get("password1")
            user = User.objects.create_user(
                username=username,
                password=password,
            )

            user.save()
            login(request, user)
            return redirect("home")

    else:
        form = UserCreationForm()

    return render(request, "registration/signup.html", {"form": form})

projects/views.py
from django.shortcuts import redirect
from django.views.generic.list import ListView
from django.views.generic.detail import DetailView
from django.views.generic.edit import CreateView
from projects.models import Project
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.base import RedirectView

# Create your views here.


class ProjectListView(LoginRequiredMixin, ListView):
    model = Project
    template_name = "projects/list.html"


def get_queryset(self):
    return Project.objects.filter(members=self.request.user)


class ProjectRedirectView(RedirectView):
    url = "/projects/"
    pattern_name = "home"


class ProjectDetailView(LoginRequiredMixin, DetailView):
    model = Project
    template_name = "projects/detail.html"

    def get_queryset(self):
        return Project.objects.filter(members=self.request.user)


class ProjectCreateView(LoginRequiredMixin, CreateView):
    model = Project
    template_name = "projects/create.html"
    fields = ["name", "description", "members"]

    def form_valid(self, form):
        project = form.save(commit=False)
        project.member = self.request.user
        project.save()
        form.save_m2m()
        return redirect("show_project", pk=project.id)

tasks/views.py
from django.shortcuts import redirect
from django.views.generic.edit import CreateView
from django.views.generic.list import ListView
from django.contrib.auth.mixins import LoginRequiredMixin
from .models import Task


# Create your views here.


class TaskCreateView(LoginRequiredMixin, CreateView):
    model = Task
    template_name = "tasks/create.html"
    fields = ["name", "start_date", "due_date", "project", "assignee"]

    def form_valid(self, form):
        task = form.save(commit=False)
        task.assignee = self.request.user
        task.save()
        return redirect("show_project", pk=task.project.id)


class TaskListView(LoginRequiredMixin, ListView):
    model = Task
    template_name = "tasks/list.html"

    def get_queryset(self):
        return Task.objects.filter(assignee=self.request.user)

projects/templates/base.html
{% load static %}

<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>My Projects</title>
</head>

<body>
    <header>
        <nav>
            <ul class="navigation">
                {% if user.is_authenticated %}
                <li class="nav-item">
                    <a href="{% url 'home' %}">Projects</a>
                </li>
                <li class="nav-item">
                    <a href="{% url 'logout' %}">Logout</a>
                </li>
                {% else %}
                <li class="nav-item">
                    <a href="{% url 'signup' %}">Sign Up</a>
                </li>
                <li class="nav-item">
                    <a href="{% url 'login' %}">Login</a>
                </li>
                {% endif %}
            </ul>
        </nav>
    </header>
    <main>
        {% block content %}
        {% endblock content %}
    </main>


</body>

</html>

projects/templates/projects/create.html
{% extends "base.html" %}
{% block content %}
<main>
    <div>
        <h1>Create a new project</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="control">
                <button class="button">Create</button>
            </div>
        </form>
    </div>
</main>
{% endblock content %}

projects/templates/projects/detail.html
{% extends "base.html" %}
{% block content %}
{% load markdownify %}
<main>
    <div>
        <h1>{{project.name}}</h1>
        <p>{{ project.description|markdownify }}</p>
        <h2>Tasks</h2>
        <p>
            <a href="{% url  'create_task' %}">Create a new task</a>
        </p>
        {% if project.tasks.all|length == 0 %}
        <p>This project has no tasks</p>
        {% else %}
        <table>
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Assignee</th>
                    <th>Start date</th>
                    <th>Due date</th>
                    <th>Is completed</th>
                </tr>
            </thead>
            <tbody>
                {% for task in project.tasks.all %}
                <tr>
                    <td>{{task.name}}</td>
                    <td>{{task.assignee}}</td>
                    <td>{{task.start_date}}</td>
                    <td>{{task.due_date}}</td>
                    {% if task.is_completed == True %}
                    <td>yes</td>
                    {% else %}
                    <td>no</td>
                    {% endif %}
                </tr>
                {% endfor %}
            </tbody>
        </table>
        {% endif %}
    </div>
</main>
{% endblock content %}

projects/templates/projects/list.html
{% extends "base.html" %}

{% block content %}
<main>
    <div>
        <h1>My Projects </h1>
        <p>
            <a href="{% url 'create_project' %}">Create a new project</a>
        </p>
        {% if project_list|length == 0 %}
        <p>You are not assigned to any projects</p>
        {% else %}
        <table>
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Number of tasks</th>
                </tr>
            </thead>
            <tbody>
                {% for item in project_list %}
                <tr>
                    <td>
                        <a href="{% url 'show_project' item.pk %}">{{ item.name }}</a>
                    </td>
                    <td>{{ item.tasks.all|length }}</td>
                </tr>
                {% endfor %}
            </tbody>
        </table>
        {% endif %}
    </div>
</main>
{% endblock content %}

tasks/templates/create.html
{% extends "base.html" %}
{% block content %}
<main>
    <div>
        <h1>Create a new task</h1>
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="control">
                <button class="button">Create</button>
            </div>
        </form>
    </div>
</main>
{% endblock content %}

tasks/templates/tasks/list.html
{% extends "base.html" %}
{% block content %}
<main>
    <div>
        <h1>My Tasks</h1>
        {% if task_list|length == 0 %}
        <p>You have no tasks</p>
        {% else %}
        <table>
            <thead>
                <tr>
                    <th>Name</th>
                    <th>Start Date</th>
                    <th>Due date</th>
                    <th>Is completed</th>
                </tr>
            </thead>
            <tbody>
                {% for task in task_list %}
                <tr>
                    <td>{{task.name}}</td>
                    <td>{{task.start_date}}</td>
                    <td>{{task.due_date}}</td>
                    {% if task.is_completed == True %}
                    <td>Done</td>
                    {% else %}
                    <td>
                        </form>
                    </td>
                    {% endif %}
                </tr>
                {% endfor %}
            </tbody>
        </table>
        {% endif %}
    </div>
</main>
{% endblock content %}